<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">Syntax.Constituent</span><span>
</span><span id="line-2"></span><span>  </span><span class="hs-special">(</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#NPConstituent"><span class="hs-identifier">NPConstituent</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-3"></span><span>    </span><span class="annot"><a href="Syntax.Constituent.html#VPConstituent"><span class="hs-identifier">VPConstituent</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-4"></span><span>    </span><span class="annot"><a href="Syntax.Constituent.html#Sentence"><span class="hs-identifier">Sentence</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-5"></span><span>    </span><span class="annot"><a href="Syntax.Constituent.html#Tag"><span class="hs-identifier">Tag</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-6"></span><span>    </span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier">Constituent</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-7"></span><span>    </span><span class="annot"><a href="Syntax.Constituent.html#getFeatures"><span class="hs-identifier">getFeatures</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-8"></span><span>    </span><span class="annot"><a href="Syntax.Constituent.html#getTags"><span class="hs-identifier">getTags</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-9"></span><span>    </span><span class="annot"><a href="Syntax.Constituent.html#addTag"><span class="hs-identifier">addTag</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-10"></span><span>    </span><span class="annot"><a href="Syntax.Constituent.html#addTags"><span class="hs-identifier">addTags</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-11"></span><span>    </span><span class="annot"><a href="Syntax.Constituent.html#getConstituents"><span class="hs-identifier">getConstituents</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-12"></span><span>    </span><span class="annot"><a href="Syntax.Constituent.html#setConstituents"><span class="hs-identifier">setConstituents</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-13"></span><span>    </span><span class="annot"><a href="Syntax.Constituent.html#instantiate"><span class="hs-identifier">instantiate</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-14"></span><span>  </span><span class="hs-special">)</span><span>
</span><span id="line-15"></span><span class="hs-keyword">where</span><span>
</span><span id="line-16"></span><span>
</span><span id="line-17"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.Char</span></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">Char</span></span><span>
</span><span id="line-18"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.List</span></span><span>
</span><span id="line-19"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="EuskeraAppError.html"><span class="hs-identifier">EuskeraAppError</span></a></span><span>
</span><span id="line-20"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Features.html"><span class="hs-identifier">Features</span></a></span><span>
</span><span id="line-21"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Lexis.html"><span class="hs-identifier">Lexis</span></a></span><span>
</span><span id="line-22"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Morphology.Inflection.html"><span class="hs-identifier">Morphology.Inflection</span></a></span><span>
</span><span id="line-23"></span><span>
</span><span id="line-24"></span><span class="hs-keyword">type</span><span> </span><span id="NPConstituent"><span class="annot"><a href="Syntax.Constituent.html#NPConstituent"><span class="hs-identifier hs-var">NPConstituent</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span>
</span><span id="line-25"></span><span>
</span><span id="line-26"></span><span class="hs-keyword">type</span><span> </span><span id="VPConstituent"><span class="annot"><a href="Syntax.Constituent.html#VPConstituent"><span class="hs-identifier hs-var">VPConstituent</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span>
</span><span id="line-27"></span><span>
</span><span id="line-28"></span><span class="hs-keyword">type</span><span> </span><span id="Sentence"><span class="annot"><a href="Syntax.Constituent.html#Sentence"><span class="hs-identifier hs-var">Sentence</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span>
</span><span id="line-29"></span><span>
</span><span id="line-30"></span><span class="hs-keyword">type</span><span> </span><span id="Tag"><span class="annot"><a href="Syntax.Constituent.html#Tag"><span class="hs-identifier hs-var">Tag</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="hs-identifier hs-type">String</span></span><span>
</span><span id="line-31"></span><span>
</span><span id="line-32"></span><span class="hs-comment">-- | Syntactic tree, tagged</span><span>
</span><span id="line-33"></span><span class="hs-keyword">data</span><span> </span><span id="Constituent"><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-var">Constituent</span></a></span></span><span>
</span><span id="line-34"></span><span>  </span><span class="hs-glyph">=</span><span> </span><span class="hs-comment">-- | Sentential constituent</span><span>
</span><span id="line-35"></span><span>    </span><span id="S"><span class="annot"><a href="Syntax.Constituent.html#S"><span class="hs-identifier hs-var">S</span></a></span></span><span> </span><span class="hs-special">[</span><span class="annot"><a href="Syntax.Constituent.html#Tag"><span class="hs-identifier hs-type">Tag</span></a></span><span class="hs-special">]</span><span> </span><span class="annot"><a href="Features.Sentential.html#SF"><span class="hs-identifier hs-type">SF</span></a></span><span> </span><span class="hs-special">[</span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span class="hs-special">]</span><span>
</span><span id="line-36"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="hs-comment">-- | Verbal phrase</span><span>
</span><span id="line-37"></span><span>    </span><span id="VP"><span class="annot"><a href="Syntax.Constituent.html#VP"><span class="hs-identifier hs-var">VP</span></a></span></span><span> </span><span class="hs-special">[</span><span class="annot"><a href="Syntax.Constituent.html#Tag"><span class="hs-identifier hs-type">Tag</span></a></span><span class="hs-special">]</span><span> </span><span class="annot"><a href="Features.Verbal.html#VF"><span class="hs-identifier hs-type">VF</span></a></span><span> </span><span class="hs-special">[</span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span class="hs-special">]</span><span>
</span><span id="line-38"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="hs-comment">-- | Noun phrase</span><span>
</span><span id="line-39"></span><span>    </span><span id="NP"><span class="annot"><a href="Syntax.Constituent.html#NP"><span class="hs-identifier hs-var">NP</span></a></span></span><span> </span><span class="hs-special">[</span><span class="annot"><a href="Syntax.Constituent.html#Tag"><span class="hs-identifier hs-type">Tag</span></a></span><span class="hs-special">]</span><span> </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span> </span><span class="hs-special">[</span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span class="hs-special">]</span><span>
</span><span id="line-40"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="hs-comment">-- | Bare lexical item</span><span>
</span><span id="line-41"></span><span>    </span><span id="L"><span class="annot"><a href="Syntax.Constituent.html#L"><span class="hs-identifier hs-var">L</span></a></span></span><span> </span><span class="hs-special">[</span><span class="annot"><a href="Syntax.Constituent.html#Tag"><span class="hs-identifier hs-type">Tag</span></a></span><span class="hs-special">]</span><span> </span><span class="annot"><a href="Lexis.html#Lexis"><span class="hs-identifier hs-type">Lexis</span></a></span><span>
</span><span id="line-42"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="hs-comment">-- | Gap in substitution of constituent. If set to True, the gap will be</span><span>
</span><span id="line-43"></span><span>    </span><span class="hs-comment">-- a horizontal line. Otherwise, it will be an invisible gap.</span><span>
</span><span id="line-44"></span><span>    </span><span id="FillGap"><span class="annot"><a href="Syntax.Constituent.html#FillGap"><span class="hs-identifier hs-var">FillGap</span></a></span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Bool</span></span><span>
</span><span id="line-45"></span><span>  </span><span class="hs-keyword">deriving</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679082436"><span id="local-6989586621679082438"><span id="local-6989586621679082440"><span class="annot"><span class="annottext">Int -&gt; Constituent -&gt; ShowS
[Constituent] -&gt; ShowS
Constituent -&gt; String
(Int -&gt; Constituent -&gt; ShowS)
-&gt; (Constituent -&gt; String)
-&gt; ([Constituent] -&gt; ShowS)
-&gt; Show Constituent
forall a.
(Int -&gt; a -&gt; ShowS) -&gt; (a -&gt; String) -&gt; ([a] -&gt; ShowS) -&gt; Show a
showList :: [Constituent] -&gt; ShowS
$cshowList :: [Constituent] -&gt; ShowS
show :: Constituent -&gt; String
$cshow :: Constituent -&gt; String
showsPrec :: Int -&gt; Constituent -&gt; ShowS
$cshowsPrec :: Int -&gt; Constituent -&gt; ShowS
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">Show</span></span></span></span></span><span class="hs-special">)</span><span>
</span><span id="line-46"></span><span>
</span><span id="line-47"></span><span class="hs-comment">--------------------------------------------------------------------------------</span><span>
</span><span id="line-48"></span><span>
</span><span id="line-49"></span><span class="annot"><a href="Syntax.Constituent.html#getFeatures"><span class="hs-identifier hs-type">getFeatures</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Features.Wrappable.html#FeatureWrapper"><span class="hs-identifier hs-type">FeatureWrapper</span></a></span><span>
</span><span id="line-50"></span><span id="getFeatures"><span class="annot"><span class="annottext">getFeatures :: Constituent -&gt; FeatureWrapper
</span><a href="Syntax.Constituent.html#getFeatures"><span class="hs-identifier hs-var hs-var">getFeatures</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#S"><span class="hs-identifier hs-type">S</span></a></span><span> </span><span class="annot"><span class="annottext">[String]
</span><span class="hs-identifier">_</span></span><span> </span><span id="local-6989586621679082434"><span class="annot"><span class="annottext">SF
</span><a href="#local-6989586621679082434"><span class="hs-identifier hs-var">f</span></a></span></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><span class="hs-identifier">_</span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">SF -&gt; FeatureWrapper
forall a. Wrappable a =&gt; a -&gt; FeatureWrapper
</span><a href="Features.Wrappable.html#wrap"><span class="hs-identifier hs-var">wrap</span></a></span><span> </span><span class="annot"><span class="annottext">SF
</span><a href="#local-6989586621679082434"><span class="hs-identifier hs-var">f</span></a></span><span>
</span><span id="line-51"></span><span class="annot"><a href="Syntax.Constituent.html#getFeatures"><span class="hs-identifier hs-var">getFeatures</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#VP"><span class="hs-identifier hs-type">VP</span></a></span><span> </span><span class="annot"><span class="annottext">[String]
</span><span class="hs-identifier">_</span></span><span> </span><span id="local-6989586621679082432"><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082432"><span class="hs-identifier hs-var">f</span></a></span></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><span class="hs-identifier">_</span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">VF -&gt; FeatureWrapper
forall a. Wrappable a =&gt; a -&gt; FeatureWrapper
</span><a href="Features.Wrappable.html#wrap"><span class="hs-identifier hs-var">wrap</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082432"><span class="hs-identifier hs-var">f</span></a></span><span>
</span><span id="line-52"></span><span class="annot"><a href="Syntax.Constituent.html#getFeatures"><span class="hs-identifier hs-var">getFeatures</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#NP"><span class="hs-identifier hs-type">NP</span></a></span><span> </span><span class="annot"><span class="annottext">[String]
</span><span class="hs-identifier">_</span></span><span> </span><span id="local-6989586621679082431"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679082431"><span class="hs-identifier hs-var">f</span></a></span></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><span class="hs-identifier">_</span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">NF -&gt; FeatureWrapper
forall a. Wrappable a =&gt; a -&gt; FeatureWrapper
</span><a href="Features.Wrappable.html#wrap"><span class="hs-identifier hs-var">wrap</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679082431"><span class="hs-identifier hs-var">f</span></a></span><span>
</span><span id="line-53"></span><span class="annot"><a href="Syntax.Constituent.html#getFeatures"><span class="hs-identifier hs-var">getFeatures</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#L"><span class="hs-identifier hs-type">L</span></a></span><span> </span><span class="annot"><span class="annottext">[String]
</span><span class="hs-identifier">_</span></span><span> </span><span id="local-6989586621679082430"><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679082430"><span class="hs-identifier hs-var">lexis</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Lexis -&gt; FeatureWrapper
</span><a href="Lexis.html#getLFeatures"><span class="hs-identifier hs-var">getLFeatures</span></a></span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679082430"><span class="hs-identifier hs-var">lexis</span></a></span><span>
</span><span id="line-54"></span><span class="annot"><a href="Syntax.Constituent.html#getFeatures"><span class="hs-identifier hs-var">getFeatures</span></a></span><span> </span><span class="annot"><span class="annottext">Constituent
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">String -&gt; FeatureWrapper
forall a. HasCallStack =&gt; String -&gt; a
</span><span class="hs-identifier hs-var">error</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;Constituent type without features&quot;</span></span><span>
</span><span id="line-55"></span><span>
</span><span id="line-56"></span><span class="annot"><a href="Syntax.Constituent.html#getTags"><span class="hs-identifier hs-type">getTags</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-special">[</span><span class="annot"><a href="Syntax.Constituent.html#Tag"><span class="hs-identifier hs-type">Tag</span></a></span><span class="hs-special">]</span><span>
</span><span id="line-57"></span><span id="getTags"><span class="annot"><span class="annottext">getTags :: Constituent -&gt; [String]
</span><a href="Syntax.Constituent.html#getTags"><span class="hs-identifier hs-var hs-var">getTags</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#S"><span class="hs-identifier hs-type">S</span></a></span><span> </span><span id="local-6989586621679082427"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082427"><span class="hs-identifier hs-var">ts</span></a></span></span><span> </span><span class="annot"><span class="annottext">SF
</span><span class="hs-identifier">_</span></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><span class="hs-identifier">_</span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082427"><span class="hs-identifier hs-var">ts</span></a></span><span>
</span><span id="line-58"></span><span class="annot"><a href="Syntax.Constituent.html#getTags"><span class="hs-identifier hs-var">getTags</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#VP"><span class="hs-identifier hs-type">VP</span></a></span><span> </span><span id="local-6989586621679082426"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082426"><span class="hs-identifier hs-var">ts</span></a></span></span><span> </span><span class="annot"><span class="annottext">VF
</span><span class="hs-identifier">_</span></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><span class="hs-identifier">_</span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082426"><span class="hs-identifier hs-var">ts</span></a></span><span>
</span><span id="line-59"></span><span class="annot"><a href="Syntax.Constituent.html#getTags"><span class="hs-identifier hs-var">getTags</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#NP"><span class="hs-identifier hs-type">NP</span></a></span><span> </span><span id="local-6989586621679082425"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082425"><span class="hs-identifier hs-var">ts</span></a></span></span><span> </span><span class="annot"><span class="annottext">NF
</span><span class="hs-identifier">_</span></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><span class="hs-identifier">_</span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082425"><span class="hs-identifier hs-var">ts</span></a></span><span>
</span><span id="line-60"></span><span class="annot"><a href="Syntax.Constituent.html#getTags"><span class="hs-identifier hs-var">getTags</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#L"><span class="hs-identifier hs-type">L</span></a></span><span> </span><span id="local-6989586621679082424"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082424"><span class="hs-identifier hs-var">ts</span></a></span></span><span> </span><span class="annot"><span class="annottext">Lexis
</span><span class="hs-identifier">_</span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082424"><span class="hs-identifier hs-var">ts</span></a></span><span>
</span><span id="line-61"></span><span class="annot"><a href="Syntax.Constituent.html#getTags"><span class="hs-identifier hs-var">getTags</span></a></span><span> </span><span class="annot"><a href="Syntax.Constituent.html#FillGap"><span class="hs-identifier hs-type">FillGap</span></a></span><span> </span><span class="hs-special">{</span><span class="hs-special">}</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-special">[</span><span class="hs-special">]</span><span>
</span><span id="line-62"></span><span>
</span><span id="line-63"></span><span class="hs-comment">-- | Add one tag as the head of the Constituent's tag list</span><span>
</span><span id="line-64"></span><span class="annot"><a href="Syntax.Constituent.html#addTag"><span class="hs-identifier hs-type">addTag</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Tag"><span class="hs-identifier hs-type">Tag</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span>
</span><span id="line-65"></span><span id="addTag"><span class="annot"><span class="annottext">addTag :: String -&gt; Constituent -&gt; Constituent
</span><a href="Syntax.Constituent.html#addTag"><span class="hs-identifier hs-var hs-var">addTag</span></a></span></span><span> </span><span id="local-6989586621679082423"><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679082423"><span class="hs-identifier hs-var">tag</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#S"><span class="hs-identifier hs-type">S</span></a></span><span> </span><span id="local-6989586621679082422"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082422"><span class="hs-identifier hs-var">ts</span></a></span></span><span> </span><span id="local-6989586621679082421"><span class="annot"><span class="annottext">SF
</span><a href="#local-6989586621679082421"><span class="hs-identifier hs-var">sf</span></a></span></span><span> </span><span id="local-6989586621679082420"><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082420"><span class="hs-identifier hs-var">cs</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[String] -&gt; SF -&gt; [Constituent] -&gt; Constituent
</span><a href="Syntax.Constituent.html#S"><span class="hs-identifier hs-var">S</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679082423"><span class="hs-identifier hs-var">tag</span></a></span><span> </span><span class="annot"><span class="annottext">String -&gt; [String] -&gt; [String]
forall a. a -&gt; [a] -&gt; [a]
</span><span class="hs-glyph hs-var">:</span></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082422"><span class="hs-identifier hs-var">ts</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">SF
</span><a href="#local-6989586621679082421"><span class="hs-identifier hs-var">sf</span></a></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082420"><span class="hs-identifier hs-var">cs</span></a></span><span>
</span><span id="line-66"></span><span class="annot"><a href="Syntax.Constituent.html#addTag"><span class="hs-identifier hs-var">addTag</span></a></span><span> </span><span id="local-6989586621679082419"><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679082419"><span class="hs-identifier hs-var">tag</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#VP"><span class="hs-identifier hs-type">VP</span></a></span><span> </span><span id="local-6989586621679082418"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082418"><span class="hs-identifier hs-var">ts</span></a></span></span><span> </span><span id="local-6989586621679082417"><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082417"><span class="hs-identifier hs-var">vf</span></a></span></span><span> </span><span id="local-6989586621679082416"><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082416"><span class="hs-identifier hs-var">cs</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[String] -&gt; VF -&gt; [Constituent] -&gt; Constituent
</span><a href="Syntax.Constituent.html#VP"><span class="hs-identifier hs-var">VP</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679082419"><span class="hs-identifier hs-var">tag</span></a></span><span> </span><span class="annot"><span class="annottext">String -&gt; [String] -&gt; [String]
forall a. a -&gt; [a] -&gt; [a]
</span><span class="hs-glyph hs-var">:</span></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082418"><span class="hs-identifier hs-var">ts</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082417"><span class="hs-identifier hs-var">vf</span></a></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082416"><span class="hs-identifier hs-var">cs</span></a></span><span>
</span><span id="line-67"></span><span class="annot"><a href="Syntax.Constituent.html#addTag"><span class="hs-identifier hs-var">addTag</span></a></span><span> </span><span id="local-6989586621679082415"><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679082415"><span class="hs-identifier hs-var">tag</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#NP"><span class="hs-identifier hs-type">NP</span></a></span><span> </span><span id="local-6989586621679082414"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082414"><span class="hs-identifier hs-var">ts</span></a></span></span><span> </span><span id="local-6989586621679082413"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679082413"><span class="hs-identifier hs-var">nf</span></a></span></span><span> </span><span id="local-6989586621679082412"><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082412"><span class="hs-identifier hs-var">cs</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[String] -&gt; NF -&gt; [Constituent] -&gt; Constituent
</span><a href="Syntax.Constituent.html#NP"><span class="hs-identifier hs-var">NP</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679082415"><span class="hs-identifier hs-var">tag</span></a></span><span> </span><span class="annot"><span class="annottext">String -&gt; [String] -&gt; [String]
forall a. a -&gt; [a] -&gt; [a]
</span><span class="hs-glyph hs-var">:</span></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082414"><span class="hs-identifier hs-var">ts</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679082413"><span class="hs-identifier hs-var">nf</span></a></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082412"><span class="hs-identifier hs-var">cs</span></a></span><span>
</span><span id="line-68"></span><span class="annot"><a href="Syntax.Constituent.html#addTag"><span class="hs-identifier hs-var">addTag</span></a></span><span> </span><span id="local-6989586621679082411"><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679082411"><span class="hs-identifier hs-var">tag</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#L"><span class="hs-identifier hs-type">L</span></a></span><span> </span><span id="local-6989586621679082410"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082410"><span class="hs-identifier hs-var">ts</span></a></span></span><span> </span><span id="local-6989586621679082409"><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679082409"><span class="hs-identifier hs-var">l</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[String] -&gt; Lexis -&gt; Constituent
</span><a href="Syntax.Constituent.html#L"><span class="hs-identifier hs-var">L</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679082411"><span class="hs-identifier hs-var">tag</span></a></span><span> </span><span class="annot"><span class="annottext">String -&gt; [String] -&gt; [String]
forall a. a -&gt; [a] -&gt; [a]
</span><span class="hs-glyph hs-var">:</span></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082410"><span class="hs-identifier hs-var">ts</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679082409"><span class="hs-identifier hs-var">l</span></a></span><span>
</span><span id="line-69"></span><span>
</span><span id="line-70"></span><span class="hs-comment">-- | Add a list of tags as the head of the Constituent's tag list</span><span>
</span><span id="line-71"></span><span class="annot"><a href="Syntax.Constituent.html#addTags"><span class="hs-identifier hs-type">addTags</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-special">[</span><span class="annot"><a href="Syntax.Constituent.html#Tag"><span class="hs-identifier hs-type">Tag</span></a></span><span class="hs-special">]</span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span>
</span><span id="line-72"></span><span id="addTags"><span class="annot"><span class="annottext">addTags :: [String] -&gt; Constituent -&gt; Constituent
</span><a href="Syntax.Constituent.html#addTags"><span class="hs-identifier hs-var hs-var">addTags</span></a></span></span><span> </span><span id="local-6989586621679082408"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082408"><span class="hs-identifier hs-var">tags</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#S"><span class="hs-identifier hs-type">S</span></a></span><span> </span><span id="local-6989586621679082407"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082407"><span class="hs-identifier hs-var">ts</span></a></span></span><span> </span><span id="local-6989586621679082406"><span class="annot"><span class="annottext">SF
</span><a href="#local-6989586621679082406"><span class="hs-identifier hs-var">sf</span></a></span></span><span> </span><span id="local-6989586621679082405"><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082405"><span class="hs-identifier hs-var">cs</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[String] -&gt; SF -&gt; [Constituent] -&gt; Constituent
</span><a href="Syntax.Constituent.html#S"><span class="hs-identifier hs-var">S</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082408"><span class="hs-identifier hs-var">tags</span></a></span><span> </span><span class="annot"><span class="annottext">[String] -&gt; [String] -&gt; [String]
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082407"><span class="hs-identifier hs-var">ts</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">SF
</span><a href="#local-6989586621679082406"><span class="hs-identifier hs-var">sf</span></a></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082405"><span class="hs-identifier hs-var">cs</span></a></span><span>
</span><span id="line-73"></span><span class="annot"><a href="Syntax.Constituent.html#addTags"><span class="hs-identifier hs-var">addTags</span></a></span><span> </span><span id="local-6989586621679082404"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082404"><span class="hs-identifier hs-var">tags</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#VP"><span class="hs-identifier hs-type">VP</span></a></span><span> </span><span id="local-6989586621679082403"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082403"><span class="hs-identifier hs-var">ts</span></a></span></span><span> </span><span id="local-6989586621679082402"><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082402"><span class="hs-identifier hs-var">vf</span></a></span></span><span> </span><span id="local-6989586621679082401"><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082401"><span class="hs-identifier hs-var">cs</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[String] -&gt; VF -&gt; [Constituent] -&gt; Constituent
</span><a href="Syntax.Constituent.html#VP"><span class="hs-identifier hs-var">VP</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082404"><span class="hs-identifier hs-var">tags</span></a></span><span> </span><span class="annot"><span class="annottext">[String] -&gt; [String] -&gt; [String]
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082403"><span class="hs-identifier hs-var">ts</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082402"><span class="hs-identifier hs-var">vf</span></a></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082401"><span class="hs-identifier hs-var">cs</span></a></span><span>
</span><span id="line-74"></span><span class="annot"><a href="Syntax.Constituent.html#addTags"><span class="hs-identifier hs-var">addTags</span></a></span><span> </span><span id="local-6989586621679082400"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082400"><span class="hs-identifier hs-var">tags</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#NP"><span class="hs-identifier hs-type">NP</span></a></span><span> </span><span id="local-6989586621679082399"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082399"><span class="hs-identifier hs-var">ts</span></a></span></span><span> </span><span id="local-6989586621679082398"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679082398"><span class="hs-identifier hs-var">nf</span></a></span></span><span> </span><span id="local-6989586621679082397"><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082397"><span class="hs-identifier hs-var">cs</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[String] -&gt; NF -&gt; [Constituent] -&gt; Constituent
</span><a href="Syntax.Constituent.html#NP"><span class="hs-identifier hs-var">NP</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082400"><span class="hs-identifier hs-var">tags</span></a></span><span> </span><span class="annot"><span class="annottext">[String] -&gt; [String] -&gt; [String]
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082399"><span class="hs-identifier hs-var">ts</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679082398"><span class="hs-identifier hs-var">nf</span></a></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082397"><span class="hs-identifier hs-var">cs</span></a></span><span>
</span><span id="line-75"></span><span class="annot"><a href="Syntax.Constituent.html#addTags"><span class="hs-identifier hs-var">addTags</span></a></span><span> </span><span id="local-6989586621679082396"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082396"><span class="hs-identifier hs-var">tags</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#L"><span class="hs-identifier hs-type">L</span></a></span><span> </span><span id="local-6989586621679082395"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082395"><span class="hs-identifier hs-var">ts</span></a></span></span><span> </span><span id="local-6989586621679082394"><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679082394"><span class="hs-identifier hs-var">l</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[String] -&gt; Lexis -&gt; Constituent
</span><a href="Syntax.Constituent.html#L"><span class="hs-identifier hs-var">L</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082396"><span class="hs-identifier hs-var">tags</span></a></span><span> </span><span class="annot"><span class="annottext">[String] -&gt; [String] -&gt; [String]
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082395"><span class="hs-identifier hs-var">ts</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679082394"><span class="hs-identifier hs-var">l</span></a></span><span>
</span><span id="line-76"></span><span>
</span><span id="line-77"></span><span class="hs-comment">-- | Create new constituent by adding the constituent list the the source constituent</span><span>
</span><span id="line-78"></span><span class="hs-comment">-- For constructors with no constituent list, the constituent is returned unchanged</span><span>
</span><span id="line-79"></span><span class="annot"><a href="Syntax.Constituent.html#setConstituents"><span class="hs-identifier hs-type">setConstituents</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-special">[</span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span class="hs-special">]</span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span>
</span><span id="line-80"></span><span id="setConstituents"><span class="annot"><span class="annottext">setConstituents :: Constituent -&gt; [Constituent] -&gt; Constituent
</span><a href="Syntax.Constituent.html#setConstituents"><span class="hs-identifier hs-var hs-var">setConstituents</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#S"><span class="hs-identifier hs-type">S</span></a></span><span> </span><span id="local-6989586621679082393"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082393"><span class="hs-identifier hs-var">ts</span></a></span></span><span> </span><span id="local-6989586621679082392"><span class="annot"><span class="annottext">SF
</span><a href="#local-6989586621679082392"><span class="hs-identifier hs-var">sf</span></a></span></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><span class="hs-identifier">_</span></span><span class="hs-special">)</span><span> </span><span id="local-6989586621679082391"><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082391"><span class="hs-identifier hs-var">cs</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[String] -&gt; SF -&gt; [Constituent] -&gt; Constituent
</span><a href="Syntax.Constituent.html#S"><span class="hs-identifier hs-var">S</span></a></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082393"><span class="hs-identifier hs-var">ts</span></a></span><span> </span><span class="annot"><span class="annottext">SF
</span><a href="#local-6989586621679082392"><span class="hs-identifier hs-var">sf</span></a></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082391"><span class="hs-identifier hs-var">cs</span></a></span><span>
</span><span id="line-81"></span><span class="annot"><a href="Syntax.Constituent.html#setConstituents"><span class="hs-identifier hs-var">setConstituents</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#VP"><span class="hs-identifier hs-type">VP</span></a></span><span> </span><span id="local-6989586621679082390"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082390"><span class="hs-identifier hs-var">ts</span></a></span></span><span> </span><span id="local-6989586621679082389"><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082389"><span class="hs-identifier hs-var">vf</span></a></span></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><span class="hs-identifier">_</span></span><span class="hs-special">)</span><span> </span><span id="local-6989586621679082388"><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082388"><span class="hs-identifier hs-var">cs</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[String] -&gt; VF -&gt; [Constituent] -&gt; Constituent
</span><a href="Syntax.Constituent.html#VP"><span class="hs-identifier hs-var">VP</span></a></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082390"><span class="hs-identifier hs-var">ts</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082389"><span class="hs-identifier hs-var">vf</span></a></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082388"><span class="hs-identifier hs-var">cs</span></a></span><span>
</span><span id="line-82"></span><span class="annot"><a href="Syntax.Constituent.html#setConstituents"><span class="hs-identifier hs-var">setConstituents</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#NP"><span class="hs-identifier hs-type">NP</span></a></span><span> </span><span id="local-6989586621679082387"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082387"><span class="hs-identifier hs-var">ts</span></a></span></span><span> </span><span id="local-6989586621679082386"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679082386"><span class="hs-identifier hs-var">nf</span></a></span></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><span class="hs-identifier">_</span></span><span class="hs-special">)</span><span> </span><span id="local-6989586621679082385"><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082385"><span class="hs-identifier hs-var">cs</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[String] -&gt; NF -&gt; [Constituent] -&gt; Constituent
</span><a href="Syntax.Constituent.html#NP"><span class="hs-identifier hs-var">NP</span></a></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082387"><span class="hs-identifier hs-var">ts</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679082386"><span class="hs-identifier hs-var">nf</span></a></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082385"><span class="hs-identifier hs-var">cs</span></a></span><span>
</span><span id="line-83"></span><span class="annot"><a href="Syntax.Constituent.html#setConstituents"><span class="hs-identifier hs-var">setConstituents</span></a></span><span> </span><span id="local-6989586621679082384"><span class="annot"><span class="annottext">Constituent
</span><a href="#local-6989586621679082384"><span class="hs-identifier hs-var">x</span></a></span></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Constituent
</span><a href="#local-6989586621679082384"><span class="hs-identifier hs-var">x</span></a></span><span>
</span><span id="line-84"></span><span>
</span><span id="line-85"></span><span class="hs-comment">-- | Retrieve Constituents that form fiven Constituent</span><span>
</span><span id="line-86"></span><span class="annot"><a href="Syntax.Constituent.html#getConstituents"><span class="hs-identifier hs-type">getConstituents</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-special">[</span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span class="hs-special">]</span><span>
</span><span id="line-87"></span><span id="getConstituents"><span class="annot"><span class="annottext">getConstituents :: Constituent -&gt; [Constituent]
</span><a href="Syntax.Constituent.html#getConstituents"><span class="hs-identifier hs-var hs-var">getConstituents</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#S"><span class="hs-identifier hs-type">S</span></a></span><span> </span><span class="annot"><span class="annottext">[String]
</span><span class="hs-identifier">_</span></span><span> </span><span class="annot"><span class="annottext">SF
</span><span class="hs-identifier">_</span></span><span> </span><span id="local-6989586621679082383"><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082383"><span class="hs-identifier hs-var">cs</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082383"><span class="hs-identifier hs-var">cs</span></a></span><span>
</span><span id="line-88"></span><span class="annot"><a href="Syntax.Constituent.html#getConstituents"><span class="hs-identifier hs-var">getConstituents</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#VP"><span class="hs-identifier hs-type">VP</span></a></span><span> </span><span class="annot"><span class="annottext">[String]
</span><span class="hs-identifier">_</span></span><span> </span><span class="annot"><span class="annottext">VF
</span><span class="hs-identifier">_</span></span><span> </span><span id="local-6989586621679082382"><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082382"><span class="hs-identifier hs-var">cs</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082382"><span class="hs-identifier hs-var">cs</span></a></span><span>
</span><span id="line-89"></span><span class="annot"><a href="Syntax.Constituent.html#getConstituents"><span class="hs-identifier hs-var">getConstituents</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#NP"><span class="hs-identifier hs-type">NP</span></a></span><span> </span><span class="annot"><span class="annottext">[String]
</span><span class="hs-identifier">_</span></span><span> </span><span class="annot"><span class="annottext">NF
</span><span class="hs-identifier">_</span></span><span> </span><span id="local-6989586621679082381"><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082381"><span class="hs-identifier hs-var">cs</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082381"><span class="hs-identifier hs-var">cs</span></a></span><span>
</span><span id="line-90"></span><span class="annot"><a href="Syntax.Constituent.html#getConstituents"><span class="hs-identifier hs-var">getConstituents</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#L"><span class="hs-identifier hs-type">L</span></a></span><span> </span><span id="local-6989586621679082380"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082380"><span class="hs-identifier hs-var">ts</span></a></span></span><span> </span><span id="local-6989586621679082379"><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679082379"><span class="hs-identifier hs-var">l</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-special">[</span><span class="annot"><span class="annottext">[String] -&gt; Lexis -&gt; Constituent
</span><a href="Syntax.Constituent.html#L"><span class="hs-identifier hs-var">L</span></a></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082380"><span class="hs-identifier hs-var">ts</span></a></span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679082379"><span class="hs-identifier hs-var">l</span></a></span><span class="hs-special">]</span><span>
</span><span id="line-91"></span><span class="annot"><a href="Syntax.Constituent.html#getConstituents"><span class="hs-identifier hs-var">getConstituents</span></a></span><span> </span><span class="annot"><span class="annottext">Constituent
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-special">[</span><span class="hs-special">]</span><span>
</span><span id="line-92"></span><span>
</span><span id="line-93"></span><span class="hs-comment">--------------------------------------------------------------------------------</span><span>
</span><span id="line-94"></span><span class="hs-comment">-- Sentence instantiation</span><span>
</span><span id="line-95"></span><span class="hs-comment">--------------------------------------------------------------------------------</span><span>
</span><span id="line-96"></span><span>
</span><span id="line-97"></span><span class="hs-comment">-- | Transform a syntactic tree (Constituent) into a sentence (String)</span><span>
</span><span id="line-98"></span><span class="annot"><a href="Syntax.Constituent.html#instantiate"><span class="hs-identifier hs-type">instantiate</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Either</span></span><span> </span><span class="annot"><a href="EuskeraAppError.html#EuskeraAppError"><span class="hs-identifier hs-type">EuskeraAppError</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">String</span></span><span>
</span><span id="line-99"></span><span id="instantiate"><span class="annot"><span class="annottext">instantiate :: Constituent -&gt; Either EuskeraAppError String
</span><a href="Syntax.Constituent.html#instantiate"><span class="hs-identifier hs-var hs-var">instantiate</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#FillGap"><span class="hs-identifier hs-type">FillGap</span></a></span><span> </span><span class="annot"><span class="annottext">Bool
</span><span class="hs-identifier hs-var">True</span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">String -&gt; Either EuskeraAppError String
forall a b. b -&gt; Either a b
</span><span class="hs-identifier hs-var">Right</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;_______&quot;</span></span><span> </span><span class="hs-comment">-- depends on features...</span><span>
</span><span id="line-100"></span><span class="annot"><a href="Syntax.Constituent.html#instantiate"><span class="hs-identifier hs-var">instantiate</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#FillGap"><span class="hs-identifier hs-type">FillGap</span></a></span><span> </span><span class="annot"><span class="annottext">Bool
</span><span class="hs-identifier hs-var">False</span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">String -&gt; Either EuskeraAppError String
forall a b. b -&gt; Either a b
</span><span class="hs-identifier hs-var">Right</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;&quot;</span></span><span>
</span><span id="line-101"></span><span class="annot"><a href="Syntax.Constituent.html#instantiate"><span class="hs-identifier hs-var">instantiate</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#S"><span class="hs-identifier hs-type">S</span></a></span><span> </span><span class="annot"><span class="annottext">[String]
</span><span class="hs-identifier">_</span></span><span> </span><span id="local-6989586621679082378"><span class="annot"><span class="annottext">SF
</span><a href="#local-6989586621679082378"><span class="hs-identifier hs-var">sf</span></a></span></span><span> </span><span id="local-6989586621679082377"><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082377"><span class="hs-identifier hs-var">xps</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">SF -&gt; ShowS
</span><a href="Syntax.Constituent.html#styleSentence"><span class="hs-identifier hs-var">styleSentence</span></a></span><span> </span><span class="annot"><span class="annottext">SF
</span><a href="#local-6989586621679082378"><span class="hs-identifier hs-var">sf</span></a></span><span> </span><span class="annot"><span class="annottext">ShowS
-&gt; Either EuskeraAppError String -&gt; Either EuskeraAppError String
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-operator hs-var">&lt;$&gt;</span></span><span> </span><span class="annot"><span class="annottext">[Constituent] -&gt; Either EuskeraAppError String
</span><a href="Syntax.Constituent.html#instantiate%27"><span class="hs-identifier hs-var">instantiate'</span></a></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082377"><span class="hs-identifier hs-var">xps</span></a></span><span>
</span><span id="line-102"></span><span class="annot"><a href="Syntax.Constituent.html#instantiate"><span class="hs-identifier hs-var">instantiate</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#NP"><span class="hs-identifier hs-type">NP</span></a></span><span> </span><span class="annot"><span class="annottext">[String]
</span><span class="hs-identifier">_</span></span><span> </span><span id="local-6989586621679082373"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679082373"><span class="hs-identifier hs-var">nf</span></a></span></span><span> </span><span id="local-6989586621679082372"><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082372"><span class="hs-identifier hs-var">nps</span></a></span></span><span class="hs-special">)</span><span>
</span><span id="line-103"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">NF -&gt; Bool
</span><a href="Features.Nominal.html#coord"><span class="hs-identifier hs-var hs-var">coord</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679082373"><span class="hs-identifier hs-var">nf</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[String] -&gt; String
</span><a href="Syntax.Constituent.html#unwordsAnd"><span class="hs-identifier hs-var">unwordsAnd</span></a></span><span> </span><span class="annot"><span class="annottext">([String] -&gt; String)
-&gt; Either EuskeraAppError [String] -&gt; Either EuskeraAppError String
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-operator hs-var">&lt;$&gt;</span></span><span> </span><span class="annot"><span class="annottext">[Either EuskeraAppError String] -&gt; Either EuskeraAppError [String]
forall (t :: * -&gt; *) (f :: * -&gt; *) a.
(Traversable t, Applicative f) =&gt;
t (f a) -&gt; f (t a)
</span><span class="hs-identifier hs-var">sequenceA</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Constituent -&gt; Either EuskeraAppError String
</span><a href="Syntax.Constituent.html#instantiate"><span class="hs-identifier hs-var">instantiate</span></a></span><span> </span><span class="annot"><span class="annottext">(Constituent -&gt; Either EuskeraAppError String)
-&gt; [Constituent] -&gt; [Either EuskeraAppError String]
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-operator hs-var">&lt;$&gt;</span></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082372"><span class="hs-identifier hs-var">nps</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-104"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">Bool
</span><span class="hs-identifier hs-var">otherwise</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[Constituent] -&gt; Either EuskeraAppError String
</span><a href="Syntax.Constituent.html#instantiate%27"><span class="hs-identifier hs-var">instantiate'</span></a></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082372"><span class="hs-identifier hs-var">nps</span></a></span><span>
</span><span id="line-105"></span><span class="annot"><a href="Syntax.Constituent.html#instantiate"><span class="hs-identifier hs-var">instantiate</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#VP"><span class="hs-identifier hs-type">VP</span></a></span><span> </span><span class="annot"><span class="annottext">[String]
</span><span class="hs-identifier">_</span></span><span> </span><span class="annot"><span class="annottext">VF
</span><span class="hs-identifier">_</span></span><span> </span><span id="local-6989586621679082368"><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082368"><span class="hs-identifier hs-var">vps</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[Constituent] -&gt; Either EuskeraAppError String
</span><a href="Syntax.Constituent.html#instantiate%27"><span class="hs-identifier hs-var">instantiate'</span></a></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082368"><span class="hs-identifier hs-var">vps</span></a></span><span>
</span><span id="line-106"></span><span class="annot"><a href="Syntax.Constituent.html#instantiate"><span class="hs-identifier hs-var">instantiate</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#L"><span class="hs-identifier hs-type">L</span></a></span><span> </span><span class="annot"><span class="annottext">[String]
</span><span class="hs-identifier">_</span></span><span> </span><span id="local-6989586621679082367"><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679082367"><span class="hs-identifier hs-var">word</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Lexis -&gt; Either EuskeraAppError String
</span><a href="Morphology.Inflection.html#inflect"><span class="hs-identifier hs-var">inflect</span></a></span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679082367"><span class="hs-identifier hs-var">word</span></a></span><span>
</span><span id="line-107"></span><span>
</span><span id="line-108"></span><span class="annot"><a href="Syntax.Constituent.html#instantiate%27"><span class="hs-identifier hs-type">instantiate'</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-special">[</span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span class="hs-special">]</span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Either</span></span><span> </span><span class="annot"><a href="EuskeraAppError.html#EuskeraAppError"><span class="hs-identifier hs-type">EuskeraAppError</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">String</span></span><span>
</span><span id="line-109"></span><span id="instantiate%27"><span class="annot"><span class="annottext">instantiate' :: [Constituent] -&gt; Either EuskeraAppError String
</span><a href="Syntax.Constituent.html#instantiate%27"><span class="hs-identifier hs-var hs-var">instantiate'</span></a></span></span><span> </span><span id="local-6989586621679082365"><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082365"><span class="hs-identifier hs-var">xps</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[String] -&gt; String
</span><span class="hs-identifier hs-var">unwords</span></span><span> </span><span class="annot"><span class="annottext">([String] -&gt; String)
-&gt; Either EuskeraAppError [String] -&gt; Either EuskeraAppError String
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-operator hs-var">&lt;$&gt;</span></span><span> </span><span class="annot"><span class="annottext">[Either EuskeraAppError String] -&gt; Either EuskeraAppError [String]
forall (t :: * -&gt; *) (f :: * -&gt; *) a.
(Traversable t, Applicative f) =&gt;
t (f a) -&gt; f (t a)
</span><span class="hs-identifier hs-var">sequenceA</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Constituent -&gt; Either EuskeraAppError String
</span><a href="Syntax.Constituent.html#instantiate"><span class="hs-identifier hs-var">instantiate</span></a></span><span> </span><span class="annot"><span class="annottext">(Constituent -&gt; Either EuskeraAppError String)
-&gt; [Constituent] -&gt; [Either EuskeraAppError String]
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-operator hs-var">&lt;$&gt;</span></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679082365"><span class="hs-identifier hs-var">xps</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-110"></span><span>
</span><span id="line-111"></span><span class="hs-comment">-- Join constituents with &quot;eta&quot; (and)</span><span>
</span><span id="line-112"></span><span class="annot"><a href="Syntax.Constituent.html#unwordsAnd"><span class="hs-identifier hs-type">unwordsAnd</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-special">[</span><span class="annot"><span class="hs-identifier hs-type">String</span></span><span class="hs-special">]</span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">String</span></span><span>
</span><span id="line-113"></span><span id="unwordsAnd"><span class="annot"><span class="annottext">unwordsAnd :: [String] -&gt; String
</span><a href="Syntax.Constituent.html#unwordsAnd"><span class="hs-identifier hs-var hs-var">unwordsAnd</span></a></span></span><span> </span><span class="hs-special">[</span><span class="hs-special">]</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;&quot;</span></span><span>
</span><span id="line-114"></span><span class="annot"><a href="Syntax.Constituent.html#unwordsAnd"><span class="hs-identifier hs-var">unwordsAnd</span></a></span><span> </span><span id="local-6989586621679082363"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082363"><span class="hs-identifier hs-var">ws</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(String -&gt; ShowS) -&gt; [String] -&gt; String
forall (t :: * -&gt; *) a. Foldable t =&gt; (a -&gt; a -&gt; a) -&gt; t a -&gt; a
</span><span class="hs-identifier hs-var">foldr1</span></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">\</span><span id="local-6989586621679082361"><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679082361"><span class="hs-identifier hs-var">w</span></a></span></span><span> </span><span id="local-6989586621679082360"><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679082360"><span class="hs-identifier hs-var">s</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679082361"><span class="hs-identifier hs-var">w</span></a></span><span> </span><span class="annot"><span class="annottext">String -&gt; ShowS
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot; eta &quot;</span></span><span> </span><span class="annot"><span class="annottext">String -&gt; ShowS
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679082360"><span class="hs-identifier hs-var">s</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082363"><span class="hs-identifier hs-var">ws</span></a></span><span>
</span><span id="line-115"></span><span>
</span><span id="line-116"></span><span class="hs-comment">-- Add appropriate punctuation marks</span><span>
</span><span id="line-117"></span><span class="annot"><a href="Syntax.Constituent.html#styleSentence"><span class="hs-identifier hs-type">styleSentence</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Sentential.html#SF"><span class="hs-identifier hs-type">SF</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">String</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">String</span></span><span>
</span><span id="line-118"></span><span id="styleSentence"><span class="annot"><span class="annottext">styleSentence :: SF -&gt; ShowS
</span><a href="Syntax.Constituent.html#styleSentence"><span class="hs-identifier hs-var hs-var">styleSentence</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Features.Sentential.html#SF"><span class="hs-identifier hs-type">SF</span></a></span><span> </span><span id="local-6989586621679082358"><span class="annot"><span class="annottext">SentenceType
</span><a href="#local-6989586621679082358"><span class="hs-identifier hs-var">t</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679082357"><span class="annot"><span class="annottext">Char
</span><a href="#local-6989586621679082357"><span class="hs-identifier hs-var">first</span></a></span></span><span> </span><span class="annot"><span class="hs-glyph hs-type">:</span></span><span> </span><span id="local-6989586621679082356"><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679082356"><span class="hs-identifier hs-var">rest</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-keyword">case</span><span> </span><span class="annot"><span class="annottext">SentenceType
</span><a href="#local-6989586621679082358"><span class="hs-identifier hs-var">t</span></a></span><span> </span><span class="hs-keyword">of</span><span>
</span><span id="line-119"></span><span>  </span><span class="annot"><span class="annottext">SentenceType
</span><a href="Features.Sentential.html#Declarative"><span class="hs-identifier hs-var">Declarative</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679082354"><span class="hs-identifier hs-var">s</span></a></span><span> </span><span class="annot"><span class="annottext">String -&gt; ShowS
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;.&quot;</span></span><span>
</span><span id="line-120"></span><span>  </span><span class="annot"><span class="annottext">SentenceType
</span><a href="Features.Sentential.html#YesNoInterrogative"><span class="hs-identifier hs-var">YesNoInterrogative</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679082354"><span class="hs-identifier hs-var">s</span></a></span><span> </span><span class="annot"><span class="annottext">String -&gt; ShowS
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;?&quot;</span></span><span>
</span><span id="line-121"></span><span>  </span><span class="hs-keyword">where</span><span>
</span><span id="line-122"></span><span>    </span><span id="local-6989586621679082354"><span class="annot"><span class="annottext">s :: String
</span><a href="#local-6989586621679082354"><span class="hs-identifier hs-var hs-var">s</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(Char -&gt; Bool) -&gt; ShowS
forall a. (a -&gt; Bool) -&gt; [a] -&gt; [a]
</span><span class="hs-identifier hs-var">dropWhileEnd</span></span><span> </span><span class="annot"><span class="annottext">Char -&gt; Bool
</span><span class="hs-identifier hs-var">Char.isSpace</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Char -&gt; Char
</span><span class="hs-identifier hs-var">Char.toUpper</span></span><span> </span><span class="annot"><span class="annottext">Char
</span><a href="#local-6989586621679082357"><span class="hs-identifier hs-var">first</span></a></span><span> </span><span class="annot"><span class="annottext">Char -&gt; ShowS
forall a. a -&gt; [a] -&gt; [a]
</span><span class="hs-glyph hs-var">:</span></span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679082356"><span class="hs-identifier hs-var">rest</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-123"></span></pre></body></html>